Bug 83036 - [ILK]Piglit spec_ARB_copy_image_arb_copy_image-formats fails
Summary: [ILK]Piglit spec_ARB_copy_image_arb_copy_image-formats fails
Status: RESOLVED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i965 (show other bugs)
Version: unspecified
Hardware: All Linux (All)
: medium normal
Assignee: Jason Ekstrand
QA Contact: Intel 3D Bugs Mailing List
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2014-08-25 05:14 UTC by lu hua
Modified: 2016-06-22 19:29 UTC (History)
2 users (show)

See Also:
i915 platform:
i915 features:


Attachments
output (2.66 MB, text/plain)
2014-08-25 05:14 UTC, lu hua
Details
output(10.4) (126.90 KB, application/octet-stream)
2014-12-17 06:04 UTC, lu hua
Details

Note You need to log in before you can comment on or make changes to this bug.
Description lu hua 2014-08-25 05:14:41 UTC
Created attachment 105210 [details]
output

System Environment:
--------------------------
Platform: ILK
Libdrm:		(master)libdrm-2.4.56-10-g22b995d8cbf1059535c5de5ba1869c1623ae5b08
Mesa:		(master)8d8a5eb792c662a8def7c9ab65d2df67972cf659
Xserver:	(master)xorg-server-1.15.99.902-121-g2f5cf9ff9a0f713b7e038636484c77f113a5f10a
Xf86_video_intel:(master)2.99.914-67-g12c051d5c673d79c16a3a1478c0977799484ca95
Libva:		(master)acfcd5f0637a951d50c5112c7dfbd46f1d0dcdb3
Libva_intel_driver:(master)f3f49f2f0e6b3669d9b09341a11cf0b96e138674
Kernel:   (drm-intel-nightly)257d90d13794c2eb545ab0d6c708f21e2a0378b6

Bug detailed description:
---------------------------
New case spec_ARB_copy_image_arb_copy_image-formats fails on ILK with mesa master branch.It skip on mesa 10.3 branch.
It also skip on IVB with mesa master branch.

Reproduce steps:
-------------------------
1. xinit
2. bin/arb_copy_image-formats -fbo -auto
Comment 1 lu hua 2014-08-26 02:08:38 UTC
Test on latest mesa master branch, It fails on all i965 platforms.
Following new cases fail on SNB/IVB/HSW/BYT.
spec_ARB_copy_image_arb_copy_image-formats_--samples=2
spec_ARB_copy_image_arb_copy_image-formats_--samples=4
spec_ARB_copy_image_arb_copy_image-formats_--samples=8
Comment 2 lu hua 2014-08-27 01:42:42 UTC
It also fails on 10.3 branch.
Comment 3 Jason Ekstrand 2014-09-05 04:21:32 UTC
I'm aware of the failure.  However, this is not a failure of the ARB_copy_image implementation.  On the contrary, this is due to a loss of precision in the implementation of glGetTexImage.
Comment 4 Ian Romanick 2014-12-17 00:10:43 UTC
Is this still a problem?  If so... is it included in the other work Igalia is doing?
Comment 5 Jason Ekstrand 2014-12-17 00:24:04 UTC
This test can't possibly be actually running on ILK.  It requires multisample and sample_shading neither of which are advertised on ILK.  I also just verified that this skips on ILK with latest master.
Comment 6 lu hua 2014-12-17 06:04:46 UTC
Created attachment 110934 [details]
output(10.4)

Test on latest mesa master andd 10.4 branch, it still fails.
Comment 7 Jason Ekstrand 2014-12-17 11:47:24 UTC
Ok, I'm sorry, I got confused by a number of things in the report.  First, the initial report says ILK, but the test can't even run on ILK.  Please confirm what plaform you are running the test on.

Second, the arb_copy_image-formats test gets run with no arguments, with --samples=2, with --samples=4, and with --samples=8.  In the test, you say it fails with --samples=2, --samples=4, and --samples=8.  However, the output files you provide are clearly from running the test with no arguments.  Please clerify exactly how you are running the test.
Comment 8 lu hua 2014-12-18 08:41:33 UTC
(In reply to Jason Ekstrand from comment #7)
> Ok, I'm sorry, I got confused by a number of things in the report.  First,
> the initial report says ILK, but the test can't even run on ILK.  Please
> confirm what plaform you are running the test on.
> 

Run on ILK

> Second, the arb_copy_image-formats test gets run with no arguments, with
> --samples=2, with --samples=4, and with --samples=8.  In the test, you say
> it fails with --samples=2, --samples=4, and --samples=8.  However, the
> output files you provide are clearly from running the test with no
> arguments.  Please clerify exactly how you are running the test.

Attachment is from "bin/arb_copy_image-formats -fbo -auto" as comment 0. 

Test with arguments: --samples=2,  --samples=4, and  --samples=8, they are skip. The result is correct.  
[root@x-pk5 piglit]# bin/arb_copy_image-formats --samples=8 -auto -fbo
Test requires GL_ARB_texture_multisample
PIGLIT: {"result": "skip" }
[root@x-pk5 piglit]# bin/arb_copy_image-formats --samples=8 -auto -fbo
Test requires GL_ARB_texture_multisample
PIGLIT: {"result": "skip" }
[root@x-pk5 piglit]# bin/arb_copy_image-formats --samples=4 -auto -fbo
Test requires GL_ARB_texture_multisample
PIGLIT: {"result": "skip" }
[root@x-pk5 piglit]# bin/arb_copy_image-formats --samples=2 -auto -fbo
Test requires GL_ARB_texture_multisample
PIGLIT: {"result": "skip" }
Comment 9 Jason Ekstrand 2014-12-19 22:29:40 UTC
Thanks for clerifying.  A bunch of those should be fixed after the Igalia format conversion patches land which should be mid-January.  Let's see how it looks then.
Comment 10 Antia Puentes 2015-03-09 19:05:29 UTC
Tested in HSW with today's master (commit b9c2fa15e31c4904d4a2526b79ef3f70596c1074)

The "arb_copy_image-formats" test passes.
Comment 11 lu hua 2015-03-11 06:49:54 UTC
It's pass.(In reply to Antia Puentes from comment #10)
> Tested in HSW with today's master (commit
> b9c2fa15e31c4904d4a2526b79ef3f70596c1074)
> 
> The "arb_copy_image-formats" test passes.

Test it on HSW and ILK.
It works well on HSW, but fails on ILK.
Comment 12 Rhys Kidd 2015-09-16 13:29:07 UTC
Confirming on ILK with Mesa master.

The specific test being run here is this command line "bin/arb_copy_image-formats -auto -fbo". 

$ mesa-debug glxinfo | grep OpenGL
OpenGL vendor string: Intel Open Source Technology Center
OpenGL renderer string: Mesa DRI Intel(R) Ironlake Mobile 
OpenGL version string: 2.1 Mesa 11.1.0-devel (git-b8d2263)
OpenGL shading language version string: 1.20

Extract from initial part of first format with error:
100.0% of pixels match
100.0% of pixels match
100.0% of pixels match
100.0% of pixels match
100.0% of pixels match
100.0% of pixels match
100.0% of pixels match
100.0% of pixels match
texel mismatch at (24, 0); expected 0xcd, received 0x00.
texel mismatch at (25, 0); expected 0x16, received 0x00.
texel mismatch at (26, 0); expected 0x68, received 0x00.
texel mismatch at (27, 0); expected 0xba, received 0x00.
texel mismatch at (28, 0); expected 0xac, received 0x00.
Comment 13 Jason Ekstrand 2016-06-22 19:29:48 UTC
This is fixed by the following two commits:

commit 0f9cd74aab021da81a7e5a2f0fbf66213471628f
Author: Jason Ekstrand <jason.ekstrand@intel.com>
Date:   Wed Jun 22 11:11:29 2016 -0700

    i965/gen4-6: Handle gl_texture_object::BaseLevel and MinLayer correctly

commit ee39d3ba918de9d52d79bdee6db2c120bcf0f28e
Author: Jason Ekstrand <jason.ekstrand@intel.com>
Date:   Tue Jun 21 21:58:23 2016 -0700

    i965/gen4: Pull texture formats from the texture object not the miptree


bug/show.html.tmpl processed on Mar 30, 2017 at 22:40:31.
(provided by the Example extension).